#include "sbagen.h"//for main()
#include <stdlib.h>//for malloc
#include <string.h>//for strtok

#define MAX_ARGUMENTS 20
#define MAX_LEN_ALL_ARGUMENTS 1024

__declspec(dllexport) void _stdcall runSBaGen(char arguments[])
//wrapper function for sbagen.
//converts arguments[] to argc/argv format, and passes them on to the main function.
{
	int argc=0;
	char **argv=(char **)malloc(MAX_ARGUMENTS);//allocates space for MAX_ARGUMENTS char pointers.
	char *argStr=(char *)malloc(MAX_LEN_ALL_ARGUMENTS);
	char *curArg;
	char *fileName;

	//copy argument string, so will be able to pass to the main function, through argv.
	strcpy(argStr,arguments);

	//retrieve file name from argument string - delimited by double-quotes.
	fileName=strstr(argStr,"\"");
	if (fileName)
	{
		*(fileName-1)='\0';//end argument string before the fileName
		//remove quotes from file name
		fileName++;//first quote
		fileName[strlen(fileName)-1]='\0';//second quote
	}
	
	//sbagenMain expects argv[0] to hold the calling application's name.
	//we can remove that expectation, but we want to leave the code compilable
	//as a stand-alone executable.
	argv[argc++]="fromDll";

	//retrieve flags from argument string and convert into
	//argc/argv format for passing on to the sbagenMain function
	curArg=strtok(argStr," ");
	if (curArg)
		argv[argc++]=curArg;
	while (curArg=strtok(NULL, " "))//iterate while there are still arguments
		argv[argc++]=curArg;
		
	//insert fileName
	if (fileName)
		argv[argc++]=fileName;

	//call main function
	sbagenMain(argc, argv);

	//free the pointers to the arguments
	free(argv);
}

//for compiling as an executable
void main(int argc, char **argv)
{
	sbagenMain(argc, argv);
}
